#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <sys/types.h>
       #include <sys/stat.h>
       #include <fcntl.h>


/*
 * -----------------------------
 * Definiált fv.-ek következnek!
 * -----------------------------
 */



// file betöltő fv:
int load_file_to_textview(GtkWidget *parent, GtkTextView *text_view, char *filename){
	
	GtkWidget *dialog;
	GtkTextBuffer *text_buffer;
	struct stat for_size;
	char *buffer;
	int input_file;

g_message("--==1==--\n");


/*
 * A bemenő állomány méretének megállapítása.
 */

	if (stat(filename, &for_size) != 0){
		dialog = gtk_message_dialog_new(GTK_WINDOW(parent),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_CLOSE,
						"A fájl mérete nem állapítható meg: ’%s’: %m",
						filename);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		return -1;
	}

g_message("--==2==--\n");


/*
 * Az állomány megnyitása.
 */

	buffer = g_malloc(for_size.st_size);
	input_file = open(filename, O_RDONLY);

	if (input_file == -1){
		dialog = gtk_message_dialog_new(GTK_WINDOW(parent),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_CLOSE,
						"A fájl nem nyitható meg olvasásra: ’%s’: %m",
						filename);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		g_free(buffer);
		return -1;
	}

g_message("--==3==--\n");


/*
 * Az állomány tartalmának beolvasása.
 */

	if (read(input_file, buffer, for_size.st_size) != for_size.st_size){
		dialog = gtk_message_dialog_new(GTK_WINDOW(parent),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_CLOSE,
						"A fájl nem nyitható meg olvasásra: ’%s’: %m",
						filename);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		close(input_file);
		g_free(buffer);
		return -1;
	}

g_message("--==4==--\n");


/*
 * A szöveg elhelyezése a szövegszerkesztőben.
 */

	text_buffer = gtk_text_view_get_buffer(text_view);
	gtk_text_buffer_set_text(text_buffer, buffer, for_size.st_size);

g_message("--==5==--\n");


/*
 * Az állomány rezárása, a memória felszabadítása.
 */

	close(input_file);
	g_free(buffer);
	return for_size.st_size;

}
// file betöltő fv vége.


//-----------------------------//


//filba mentés
int save_textview_to_file( GtkWidget *parent, GtkTextView *text_view, char *filename){
	int output_file;
	int written;
	
	GtkWidget *dialog;
	GtkTextBuffer *text_buffer;
	GtkTextIter start;
	GtkTextIter end;
	gchar *text;
	size_t size;

/*
 * A kimenő állomány megnyitása.
 */

	output_file = open(filename, O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR);

	if (output_file == -1){
		dialog = gtk_message_dialog_new(GTK_WINDOW(parent),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_CLOSE,
						"A fájl nem nyitható meg írásra: ’%s’: %m.",
						filename);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		close(output_file);
		return -1;
	}


/*
 * A szöveg kiolvasása a szövegszerkesztőből.
 */
	
	text_buffer = gtk_text_view_get_buffer(text_view);
	gtk_text_buffer_get_start_iter(text_buffer, &start);
	gtk_text_buffer_get_end_iter(text_buffer, &end);
	text = gtk_text_buffer_get_text(text_buffer, &start, &end, TRUE);

/*
 * A szöveg írása. Az strlen() függvény itt nem a
 * karakterek számát, hanem a foglalt memória méretét
 * adja meg.
 */

	size = strlen(text);
	if ((written=write(output_file, text, size)) != size){
		dialog = gtk_message_dialog_new(GTK_WINDOW(parent),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_CLOSE,
						"Hiba az állomány írása közben: ’%s’: %m",
						filename);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		written = -1;
	}

/*
 * A memóriaterület felszabadítása, az állomány
 * lezárása.
 */

	g_free(text);
	close(output_file);
	return written;
}
// filba mentés vége




/*
 * -------------------------------------
 * Definiált fv.-ek felsorolásának vége.
 * -------------------------------------
 */

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *window;
	GtkWidget *file_chooser;
	GtkTextView *target;
	GtkTextBuffer *textview_buffer = NULL;
	gchar *file_name;
	gint response;
	window = lookup_widget(GTK_WIDGET(menuitem), "myeditor_window");
	target = lookup_widget(GTK_WIDGET(menuitem), "myeditor_textview");
	textview_buffer = gtk_text_view_get_buffer(target);
	g_message("A szöveg hossza: %d\n", gtk_text_buffer_get_char_count(textview_buffer));
	
	
/*
* A szöveg kiolvasása a szövegszerkesztőből.
*/
	
	if ( gtk_text_buffer_get_char_count(textview_buffer) != 0 ){
		g_message("Biztos, hogy meg akarsz nyitni vmi-t? %d\n", gtk_text_buffer_get_char_count(textview_buffer));
//ez így hülyeség, de vhogy le kell ellenőriztetni, hogy üres -e v. nem -e a textview!
//üres szöveg megnyitásánál kekeckedik!


		GtkWidget *dialog;
		gint dialog_response;

		dialog = gtk_message_dialog_new (GTK_WINDOW(window),
						GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_QUESTION,
						GTK_BUTTONS_YES_NO,
						"A kérdés szövege...");
		dialog_response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		switch (dialog_response) {
		case GTK_RESPONSE_YES:
			printf("Rendben.\n");
		break;
		case GTK_RESPONSE_NO:
			printf("Nem?\n");
		break;
		default:
		printf("Nincs válasz...\n");
		}
	}
	

	
	file_chooser = gtk_file_chooser_dialog_new("Open file",
						   GTK_WINDOW(window),
						   GTK_FILE_CHOOSER_ACTION_OPEN,
						   GTK_STOCK_OPEN, GTK_RESPONSE_OK,
						   GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
						   NULL);

	response = gtk_dialog_run(GTK_DIALOG(file_chooser));
	if (response == GTK_RESPONSE_OK){
		file_name = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(file_chooser));
		g_message("File: %s\n", file_name);
		load_file_to_textview(window, target, file_name);
	}else{
		gtk_widget_destroy(file_chooser);
		return;
	}

	if (file_name != NULL)
		g_free(file_name);
	
	gtk_widget_destroy(file_chooser);
}

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *window;
	GtkWidget *save_file;
	GtkTextView *target;
	GtkTextBuffer *textview_buffer = NULL;
	gint response;
	gchar *file_name;
	window = lookup_widget(GTK_WIDGET(menuitem),"myeditor_window");
	target = lookup_widget(GTK_WIDGET(menuitem), "myeditor_textview");
	textview_buffer = gtk_text_view_get_buffer(target);

	

	save_file = gtk_file_chooser_dialog_new("Save file",
						GTK_WINDOW(window),
						GTK_FILE_CHOOSER_ACTION_SAVE,
						GTK_STOCK_SAVE, GTK_RESPONSE_OK,
						GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
						NULL);
	response = gtk_dialog_run(GTK_DIALOG(save_file));
	if (response == GTK_RESPONSE_OK){
		file_name = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(save_file));
		g_message("save ide: %s\n", file_name);
		
		save_textview_to_file( window, target, file_name);
		
//			FILE *bemenofile;
//			bemenofile = g_fopen( file_name , "w" );
//			if( bemenofile == NULL ){
//       			g_message("File Open Failed: %s\n", file_name);
//    			}else{
//				g_message("File Open Success: %s\n", file_name);
//         			g_fprintf( bemenofile, "vmi jó hosszú ékezetes szöveg, ellenőrizendő, hogy kezeli -e az ékezetes betűket a progi!\n" );
//				pclose( bemenofile );
//    			}/*if*/
	}else {
		g_message("mégsem gomb, vagy vmi hiba....\n");
		gtk_widget_destroy(save_file);
		return;
	}


	if (file_name != NULL)
		g_free (file_name);
	gtk_widget_destroy(save_file);
	return;

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *window;
	GtkWidget *save_file;
	GtkTextView *target;
	GtkTextBuffer *textview_buffer = NULL;
	gint response;
	gchar *file_name;
	window = lookup_widget(GTK_WIDGET(menuitem),"myeditor_window");
	target = lookup_widget(GTK_WIDGET(menuitem), "myeditor_textview");
	textview_buffer = gtk_text_view_get_buffer(target);

	

	save_file = gtk_file_chooser_dialog_new("Save as file",
						GTK_WINDOW(window),
						GTK_FILE_CHOOSER_ACTION_SAVE,
						GTK_STOCK_SAVE, GTK_RESPONSE_OK,
						GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
						NULL);
	response = gtk_dialog_run(GTK_DIALOG(save_file));
	if (response == GTK_RESPONSE_OK){
		file_name = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(save_file));
		g_message("save ide: %s\n", file_name);
		
		save_textview_to_file( window, target, file_name);
		
//			FILE *bemenofile;
//			bemenofile = g_fopen( file_name , "w" );
//			if( bemenofile == NULL ){
//       			g_message("File Open Failed: %s\n", file_name);
//    			}else{
//				g_message("File Open Success: %s\n", file_name);
//         			g_fprintf( bemenofile, "vmi jó hosszú ékezetes szöveg, ellenőrizendő, hogy kezeli -e az ékezetes betűket a progi!\n" );
//				pclose( bemenofile );
//    			}/*if*/
	}else {
		g_message("mégsem gomb, vagy vmi hiba....\n");
		gtk_widget_destroy(save_file);
		return;
	}


	if (file_name != NULL)
		g_free (file_name);
	gtk_widget_destroy(save_file);
	return;

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
g_message("EXIT\n");
gtk_exit(EXIT_SUCCESS);
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_myeditor_window_destroy             (GtkObject       *object,
                                        gpointer         user_data)
{
g_message("EXIT\n");
gtk_exit(EXIT_SUCCESS);
}

